#include <sstream>
#include <string>
#include <curl/curl.h>
#include "text.h"
#include "histogram.h"
#include "svg.h"
#include "histogram_internal.h"
#include <iostream>
#include <vector>

using namespace std;

struct Input
{
    vector<double> numbers;
    int bin_count;
};
size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;

    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);

    return data_size;
}

Input

input_data(istream& in, bool prompt)
{
    size_t number_count;
    in >> number_count;

    Input inp;
    inp.numbers.resize(number_count);

    if (prompt)
    {
        std::cerr << "enter bin_count";
    }
    inp.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        in >> inp.numbers[i];

    }

    in >> inp.bin_count;

    return inp;
}
Input
download(const string& address)
{
    stringstream buffer;

    CURL* curl = curl_easy_init();
    if (curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
         if((res == CURLE_OK) &&
     !curl_easy_getinfo(curl, CURLINFO_PRIMARY_IP, &ip) && ip) {
    cerr<<("IP: %s\n", ip);
  }

        if (res != 0)
        {
            cout << curl_easy_strerror(res);
            exit(1);
        }
    }

    curl_easy_cleanup(curl);
    return input_data(buffer, false);
}

int
main(int argc, char* argv[])
{
    Input in;
    if (argc > 1)
    {
        in = download(argv[1]);

    }
    else
    {
        in = input_data(cin, true);
    }


    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);


    return 0;
}
